{********************************************************}
{                VIRT evaluator, ver 1.0                 }
{                     Main form                          }
{       Copyright(c) Alexander Baranovsky,1999           }
{              mailto: ab@iai.donetsk.ua                 }
{********************************************************}

unit frmMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, virtcomp, Menus;
type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Memo2: TMemo;
    Label3: TLabel;
    Button1: TButton;
    MainMenu1: TMainMenu;
    Help: TMenuItem;
    VIRTlanguagemanual1: TMenuItem;
    ProgrammingwithVIRT1: TMenuItem;
    ComponentTVirtComp1: TMenuItem;
    ExtensionoftheVIRTinterpreter1: TMenuItem;
    ListBox1: TListBox;
    ComboBox1: TComboBox;
    Button2: TButton;
    Label4: TLabel;
    Panel1: TPanel;
    Label5: TLabel;
    About: TMenuItem;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure VIRTlanguagemanual1Click(Sender: TObject);
    procedure ProgrammingwithVIRT1Click(Sender: TObject);
    procedure ComponentTVirtComp1Click(Sender: TObject);
    procedure ExtensionoftheVIRTinterpreter1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ComboBox1KeyPress(Sender: TObject; var Key: Char);
    procedure ListBox1DblClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ComboBox1Enter(Sender: TObject);
    procedure ComboBox1Exit(Sender: TObject);
    procedure ListBox1Enter(Sender: TObject);
    procedure AboutClick(Sender: TObject);
  private
    VirtComp : TVirtComp;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses FrmEdit,FrmAbout;

{$R *.DFM}

var
  ConsoleMemo : TMemo;

procedure _writeln; far;  // overrides _writeln function from virtcomp.pas
var
  S : String;
begin
  S := RunVirtComp.PopVarAsString;
  ConsoleMemo.Lines.Add( S );
  RunVirtComp.PushVar( '' );
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  ComboBox1.SetFocus;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Application.HelpFile := 'VIRT.HLP';

  VirtComp := TVirtComp.Create( Self );

  Memo2.Lines.Clear;

  Memo2.Font.Name := 'Courier new';
  Memo2.Font.Size := 12;
  Memo2.Font.Color  := clWhite;
  Memo2.Brush.Color := clBlack;
  Memo2.ReadOnly := true;

  ConsoleMemo := Memo2;

  VirtComp.AppFunction( 'writeln', 1, _writeln );
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  VirtComp.Free;
end;

procedure TForm1.VIRTlanguagemanual1Click(Sender: TObject);
begin
  Application.HelpContext(0);
end;

procedure TForm1.ProgrammingwithVIRT1Click(Sender: TObject);
begin
  Application.HelpContext(2000);
end;

procedure TForm1.ComponentTVirtComp1Click(Sender: TObject);
begin
  Application.HelpContext(3000);
end;

procedure TForm1.ExtensionoftheVIRTinterpreter1Click(Sender: TObject);
begin
  Application.HelpContext(4000);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  S : String;
begin
  with TOpenDialog.Create( nil ) do
  try
    Filter := 'VIRT files (*.w)|*.W' +
              '|VIRT source files (*.w)|*.W';
    if Execute then
    begin
      S := ExtractFileName( FileName );
      if ListBox1.Items.IndexOf( S ) = -1 then
        ListBox1.Items.Add( S );
    end;
  finally
    Free;
  end;
end;

procedure TForm1.ComboBox1KeyPress(Sender: TObject; var Key: Char);
var
  T : TextFile;
  S, UsesStatement : String;
  I, P : Integer;
begin
  if Key = #13 then
  begin
    AssignFile( T, 'script.w' );
    Rewrite( T );

    if ListBox1.Items.Count > 0 then
    begin
      UsesStatement := 'uses ';

      for I:=0 to ListBox1.Items.Count - 1 do
      begin
        S := ListBox1.Items[ I ];
        P := Pos( '.', S );
        if P > 0 then
          S := Copy( S, 1, P - 1 );

        UsesStatement := UsesStatement + S;
        if I < ListBox1.Items.Count - 1 then
          UsesStatement := UsesStatement + ',';
      end;
      writeln( T, UsesStatement );
    end;

    writeln( T, 'writeln(' + ComboBox1.Text + ')' );
    writeln( T, 'return' );
    CloseFile( T );

    VirtComp.ScriptFileName := 'script.w';
    VirtComp.Clear;
    VirtComp.Run;

    S := ComboBox1.Text;
    if ComboBox1.Items.IndexOf( S ) = -1 then
       ComboBox1.Items.Add( S );

    Key := #0;
  end;
end;

procedure TForm1.ListBox1DblClick(Sender: TObject);
var
  S : String;
begin
  if ListBox1.ItemIndex >= 0 then
  begin
    S := ListBox1.Items[ ListBox1.ItemIndex ];

    Form2.ScriptFileName := S;
    Form2.Memo1.Lines.LoadFromFile( S );
    Form2.ShowModal;

    if Form2.CheckBox1.Checked then
    begin
      VirtComp.ScriptFileName := S;
      VirtComp.Clear;
      VirtComp.Parse;
    end;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.ListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if ( ListBox1.ItemIndex >= 0 ) and ( Key = vk_Delete ) then
    ListBox1.Items.Delete( ListBox1.ItemIndex );
end;

procedure TForm1.ComboBox1Enter(Sender: TObject);
begin
  Label5.Caption := ' Enter an expression';
end;

procedure TForm1.ComboBox1Exit(Sender: TObject);
begin
  Label5.Caption := '';
end;

procedure TForm1.ListBox1Enter(Sender: TObject);
begin
  if ListBox1.Items.Count > 0 then
  begin
    Label5.Caption := ' Del - delete file from list, Double click - call script editor';
  end
  else
    Label5.Caption := '';
end;

procedure TForm1.AboutClick(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

end.
